package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.CustomerAddress;
import com.ff.weijinxiao.repository.CustomerAddressRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class CustomerAddressService {

    @Resource
    private CustomerAddressRepository customerAddressRepository;

    /**
     * 创建实体
     *
     * @param customerAddress
     */
    public CustomerAddress saveCustomerAddress(CustomerAddress customerAddress) {
        return customerAddressRepository.save(customerAddress);
    }

    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public CustomerAddress findById(Integer id) {
        Optional<CustomerAddress> optional = customerAddressRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public CustomerAddress findByOnlyID(String onlyID) {
        return customerAddressRepository.findByOnlyID(onlyID);
    }

    public void deleteById(Integer id) {
        customerAddressRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<CustomerAddress> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return customerAddressRepository.findAll(SpecificationUtil.buildSpecification(param, CustomerAddress.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<CustomerAddress> findList(Map<String, Object> param) {
        return customerAddressRepository.findAll(SpecificationUtil.buildSpecification(param, CustomerAddress.class));
    }

    public CustomerAddress findByAddressAndUid(String address, String uid) {
        return customerAddressRepository.findByAddressAndUid(address, uid);
    }

}
